- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# osg::Object Class Reference

Base class/standard interface for objects which require IO support, cloning and reference counting. More...

Inheritance diagram for osg::Object:

[legend]
List of all members.

## Public Types
enum | DataVariance { DYNAMIC, STATIC }
## Public Member Functions
| Object ()
| Construct an object.
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| Copy constructor, optional CopyOp object can be used to control shallow vs deep copying of dynamic data.
virtual Object * | cloneType () const =0
| Clone the type of an object, with Object* return type.
virtual Object * | clone (const CopyOp &) const =0
| Clone an object, with Object* return type.
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
| return the name of the object's library.
virtual const char * | className () const =0
| return the name of the object's class type.
void | setDataVariance (DataVariance dv)
| Set the data variance of this object.
DataVariance | getDataVariance () const
| Get the data variance of this object.
void | setUserData (Referenced *obj)
| Set user data, data must be subclassed from Referenced to allow automatic memory handling.
Referenced * | getUserData ()
| Get user data.
const Referenced * | getUserData () const
| Get const user data.
## Protected Member Functions
virtual | ~Object ()
| Object destructor.
## Protected Attributes
DataVariance | _dataVariance
ref_ptr< Referenced > | _userData

## Detailed Description

Base class/standard interface for objects which require IO support, cloning and reference counting.

Based on GOF Composite, Prototype and Template Method patterns.

## Member Enumeration Documentation

enum osg::Object::DataVariance

  | Enumerator:
  DYNAMIC |
  STATIC |

## Constructor & Destructor Documentation

osg::Object::Object | ( |  | ) | `[inline]`

| Construct an object. Note Object is a pure virtual base class and therefore cannot be constructed on its own, only derived classes which override the clone and className methods are concrete classes and can be constructed.

osg::Object::Object | ( | const Object & | ,
|  | const CopyOp & | copyop = `CopyOp::SHALLOW_COPY`
| ) |

| Copy constructor, optional CopyOp object can be used to control shallow vs deep copying of dynamic data.

virtual osg::Object::~Object | ( |  | ) | `[inline, protected, virtual]`

| Object destructor. Note, is protected so that Objects cannot be deleted other than by being dereferenced and the reference count being zero (see osg::Referenced), preventing the deletion of nodes which are still in use. This also means that Nodes cannot be created on stack i.e Node node will not compile, forcing all nodes to be created on the heap i.e Node* node = new Node().

## Member Function Documentation

virtual const char* osg::Object::className | ( |  | ) | const`[pure virtual]`

| return the name of the object's class type. Must be defined by derived classes. Implemented in osg::Array, osg::AutoTransform, osg::Drawable, osg::DrawPixels, osg::Geometry, osg::Image, osg::ImageStream, osg::ImpostorSprite, osg::RefMatrixd, osg::RefMatrixf, osg::Node, osg::PrimitiveSet, osg::DrawArrays, osg::DrawArrayLengths, osg::DrawElementsUByte, osg::DrawElementsUShort, osg::DrawElementsUInt, osg::Shape, osg::ShapeDrawable, osg::StateAttribute, osg::StateSet, osg::Texture, osgDB::Archive, osgFX::Effect, osgGA::AnimationPathManipulator, osgGA::DriveManipulator, osgGA::FlightManipulator, osgGA::CompositeGUIEventHandler, osgGA::KeySwitchMatrixManipulator, osgGA::MatrixManipulator, osgGA::NodeTrackerManipulator, osgGA::StateSetManipulator, osgGA::TerrainManipulator, osgGA::TrackballManipulator, osgParticle::CenteredPlacer, osgParticle::Counter, osgParticle::Emitter, osgParticle::Interpolator, osgParticle::Operator, osgParticle::ParticleEffect, osgParticle::ParticleProcessor, osgParticle::Placer, osgParticle::Program, osgParticle::Shooter, osgParticle::VariableRateCounter, osgSim::Sector, osgText::Font, osgText::Font::GlyphTexture, osgText::Text, osgUtil::RenderBin, osgUtil::RenderStage, osgUtil::RenderStageLighting, and osgUtil::RenderToTextureStage.

virtual Object* osg::Object::clone | ( | const CopyOp & |  | ) | const`[pure virtual]`

| Clone an object, with Object* return type. Must be defined by derived classes. Implemented in osg::TemplateArray< T, ARRAYTYPE, DataSize, DataType >, osg::TemplateIndexArray< T, ARRAYTYPE, DataSize, DataType >, osg::AutoTransform, osg::DrawPixels, osg::Geometry, osg::Image, osg::ImageStream, osg::ImpostorSprite, osg::RefMatrixd, osg::RefMatrixf, osg::Node, osg::DrawArrays, osg::DrawArrayLengths, osg::DrawElementsUByte, osg::DrawElementsUShort, osg::DrawElementsUInt, osg::Shape, osg::ShapeDrawable, osg::StateAttribute, osg::StateSet, osg::Texture, osgText::Font, osgText::Text, osgUtil::RenderBin, osgUtil::RenderStage, osgUtil::RenderStageLighting, and osgUtil::RenderToTextureStage.

virtual Object* osg::Object::cloneType | ( |  | ) | const`[pure virtual]`

| Clone the type of an object, with Object* return type. Must be defined by derived classes. Implemented in osg::TemplateArray< T, ARRAYTYPE, DataSize, DataType >, osg::TemplateIndexArray< T, ARRAYTYPE, DataSize, DataType >, osg::AutoTransform, osg::DrawPixels, osg::Geometry, osg::Image, osg::ImageStream, osg::ImpostorSprite, osg::RefMatrixd, osg::RefMatrixf, osg::Node, osg::DrawArrays, osg::DrawArrayLengths, osg::DrawElementsUByte, osg::DrawElementsUShort, osg::DrawElementsUInt, osg::Shape, osg::ShapeDrawable, osg::StateAttribute, osg::StateSet, osg::Texture, osgText::Font, osgText::Text, osgUtil::RenderBin, osgUtil::RenderStage, osgUtil::RenderStageLighting, and osgUtil::RenderToTextureStage.

DataVariance osg::Object::getDataVariance | ( |  | ) | const`[inline]`

| Get the data variance of this object.

const Referenced* osg::Object::getUserData | ( |  | ) | const`[inline]`

| Get const user data.

Referenced* osg::Object::getUserData | ( |  | ) | `[inline]`

| Get user data.

virtual bool osg::Object::isSameKindAs | ( | const Object * |  | ) | const`[inline, virtual]`

| Reimplemented in osg::Array, osg::IndexArray, osg::AutoTransform, osg::Drawable, osg::DrawPixels, osg::Geometry, osg::Image, osg::ImageStream, osg::ImpostorSprite, osg::RefMatrixd, osg::RefMatrixf, osg::Node, osg::PrimitiveSet, osg::DrawArrays, osg::DrawArrayLengths, osg::DrawElementsUByte, osg::DrawElementsUShort, osg::DrawElementsUInt, osg::Shape, osg::ShapeDrawable, osg::StateAttribute, osg::StateSet, osg::Texture, osgFX::Effect, osgParticle::CenteredPlacer, osgParticle::Counter, osgParticle::Emitter, osgParticle::Interpolator, osgParticle::Operator, osgParticle::ParticleEffect, osgParticle::ParticleProcessor, osgParticle::Placer, osgParticle::Program, osgParticle::Shooter, osgParticle::VariableRateCounter, osgSim::Sector, osgText::Font, osgText::Text, osgUtil::RenderBin, osgUtil::RenderStage, osgUtil::RenderStageLighting, and osgUtil::RenderToTextureStage.

virtual const char* osg::Object::libraryName | ( |  | ) | const`[pure virtual]`

| return the name of the object's library. Must be defined by derived classes. The OpenSceneGraph convention is that the namespace of a library is the same as the library name. Implemented in osg::Array, osg::AutoTransform, osg::Drawable, osg::DrawPixels, osg::Geometry, osg::Image, osg::ImageStream, osg::ImpostorSprite, osg::RefMatrixd, osg::RefMatrixf, osg::Node, osg::PrimitiveSet, osg::DrawArrays, osg::DrawArrayLengths, osg::DrawElementsUByte, osg::DrawElementsUShort, osg::DrawElementsUInt, osg::Shape, osg::ShapeDrawable, osg::StateAttribute, osg::StateSet, osg::Texture, osgDB::Archive, osgFX::Effect, osgParticle::CenteredPlacer, osgParticle::Counter, osgParticle::Emitter, osgParticle::Interpolator, osgParticle::Operator, osgParticle::ParticleEffect, osgParticle::ParticleProcessor, osgParticle::Placer, osgParticle::Program, osgParticle::Shooter, osgParticle::VariableRateCounter, osgSim::Sector, osgText::Font, osgText::Text, osgUtil::RenderBin, osgUtil::RenderStageLighting, and osgUtil::RenderToTextureStage.

void osg::Object::setDataVariance | ( | DataVariance | dv | ) | `[inline]`

| Set the data variance of this object. Can be set to either STATIC for values that do not change over the lifetime of the object, or DYNAMIC for values that vary over the lifetime of the object. The DataVariance value can be used by routines such as optimzation codes that wish to share static data.

void osg::Object::setUserData | ( | Referenced * | obj | ) | `[inline]`

| Set user data, data must be subclassed from Referenced to allow automatic memory handling. If your own data isn't directly subclassed from Referenced then create an adapter object which points to your own object and handles the memory addressing.

## Member Data Documentation

DataVariance osg::Object::_dataVariance`[protected]`

ref_ptr<Referenced> osg::Object::_userData`[protected]`

The documentation for this class was generated from the following files:

- Object
- Object.cpp